﻿Imports Infragistics.Win

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim gridSource As New DataTable()
        gridSource.Columns.Add("Coll1", GetType(Integer))
        gridSource.Columns.Add("Coll2", GetType(String)).DefaultValue = "Text"
        For i As Integer = 0 To 9
            gridSource.Rows.Add(i)
        Next

        Dim comboSource As New DataTable()
        comboSource.Columns.Add("Coll1", GetType(Integer))
        comboSource.Columns.Add("Coll2", GetType(String)).DefaultValue = "ComboText"
        For i As Integer = 0 To 9
            comboSource.Rows.Add(i)
        Next
        UltraGrid1.DataSource = gridSource
        UltraCombo1.DataSource = comboSource
        UltraCombo1.ValueMember = "Coll1"
        UltraCombo1.DisplayMember = "Coll2"

        UltraGrid1.DisplayLayout.Bands(0).Columns.Add("ComboColumn")
        UltraGrid1.DisplayLayout.Bands(0).Columns("ComboColumn").EditorComponent = UltraCombo1

    End Sub

    Private Sub UltraGrid1_ClickCell(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.ClickCellEventArgs) Handles UltraGrid1.ClickCell
        Dim el As UIElement = UltraGrid1.DisplayLayout.UIElement.ElementFromPoint(UltraGrid1.PointToClient(Cursor.Position))
        If e.Cell.Column.Key = "ComboColumn" AndAlso IsOnTextArea(el) Then
            e.Cell.EditorResolved.DropDown()
        End If

    End Sub

    Private Function IsOnTextArea(ByVal elemet As UIElement) As Boolean
        If elemet Is Nothing Then
            Return True
        End If
        If TypeOf elemet Is EditorWithComboDropDownButtonUIElement Then
            Return False
        Else
            Return IsOnTextArea(elemet.Parent)
        End If

    End Function

End Class
